#include <Math.au3>
#include <String.au3>
#include <Array.au3>
#include <Word.au3>

$fil = FileOpenDialog ("    ", @ScriptDir, "  (*.smw)", 1+4)
If @error Then My_Err("   -  " & @CRLF & @CRLF & "   ?")

$aArray = FileReadToArray($fil)
if @error Then My_Err("  " & $fil)
$fil =  StringReplace($fil, ".smw", "_R.txt")

$tmp = StringSplit($aArray[0], ' ')
if $tmp[0] <> 5 Then My_Err("  " & @CRLF & @CRLF & "      5 ,    " & $tmp[0])
if $tmp[5] <> 0 Then My_Err("  " & @CRLF & @CRLF & "    013,  012!")

$N = $tmp[1] ;  
$Nt = $tmp[3] ;   
$tp = StringMid($aArray[$N+4],2,1) ;  0 - 0=1,  1 - ABCDEFGHIJK...
$Tname = StringStripWS(StringMid($aArray[$N+1],2,99), 2) ;   -     
$Aname = StringStripWS(StringMid($aArray[$N+9],2,99), 2) ;   -  

Local $Name[$N+1]   ; 
Local $Mesto[$N+1]  ; 
Local $Num[$N+1]    ; -1 1- ,2-   ..
Local $Sum[$N+1]    ; 
Local $F[$N+1]      ;    
Local $Kb[$N+1]     ;  
Local $KbBH[$N+1]   ;  BH
Local $Zb[$N+1]     ;  -

For $i = 1 To $N ;  
   $Name[$i] = StringStripWS(StringMid($aArray[$i],9,26), 2) ;    . 26   
   $Sum[$i] = 0
   $F[$i] = 0
Next
For $i = 1 To $N ;  
   For $j = 1 To $Nt
	  $tmp = StringMid($aArray[$i],60+$j*11,1) ;   
	  If $tp = 0 Then
		 If $tmp = '1' Then
			$Sum[$i] += 1
		 ElseIf $tmp = '' Then
			$Sum[$i] += 0.5
		 ElseIf $tmp <> '0' Then
			My_Err("   " & @CRLF & @CRLF & " 01,    " & $tmp)
		 EndIf
		 If StringMid($aArray[$i],59+$j*11,1) = '-' Then $F[$i] = 0.5
	  Else
         $Sum[$i] += (Asc($tmp) - Asc("A")) / 2
		 If StringMid($aArray[$i],59+$j*11,1) = '-' Then $F[$i] = (Asc($tmp) - Asc("A")) / 4
	  EndIf
   Next
   $Kb[$i] = 0
   $KbBH[$i] = 0
   $Zb[$i] = 0
Next
For $i = 1 To $N ;  
   $max = 0
   $min = 99999
   For $j = 1 To $Nt
	  If StringMid($aArray[$i],59+$j*11,1) = '-' Then ;  
		 $r3 = $Sum[$i] - $F[$i]
		 $Zb[$i] += $r3 / 2
	  Else
		 $tmp = StringMid($aArray[$i],62+$j*11,2) ;  
		 $r3 = $Sum[$tmp] - $F[$tmp] ;    
		 $r = Asc(StringMid($aArray[$i],60+$j*11,1))
		 $r2 = Asc(StringMid($aArray[$tmp],60+$j*11,1))
		 If $r > $r2 Then
			$Zb[$i] += $r3
		 ElseIf $r = $r2 Then
			$Zb[$i] += $r3 / 2
		 EndIf
	  EndIf
	  $Kb[$i] += $r3
	  If $max < $r3 Then $max = $r3
	  If $min > $r3 Then $min = $r3
   Next
   $KbBH[$i] = $Kb[$i] - $max - $min
   $Num[$i] = $i
Next

For $i = 1 To $N-1 ;   
   For $j = $i+1 To $N
	  If $Sum[$Num[$i]] < $Sum[$Num[$j]] Then
		 Swap($i, $j)
	  ElseIf $Sum[$Num[$i]] = $Sum[$Num[$j]] Then
		 If $Kb[$Num[$i]] < $Kb[$Num[$j]] Then
			Swap($i, $j)
		 ElseIf $Kb[$Num[$i]] = $Kb[$Num[$j]] Then
			If $Zb[$Num[$i]] < $Zb[$Num[$j]] Then
			   Swap($i, $j)
			ElseIf $Zb[$Num[$i]] = $Zb[$Num[$j]] Then
			   If $KbBH[$Num[$i]] < $KbBH[$Num[$j]] Then
				  Swap($i, $j)
			   ElseIf $KbBH[$Num[$i]] = $KbBH[$Num[$j]] Then
				  My_Err(" " & @CRLF & @CRLF & "    ")
			   EndIf
			EndIf
		 EndIf
	  EndIf
   Next
Next
For $i = 1 To $N ;  
   $Mesto[$Num[$i]] = $i
Next

;_ArrayDisplay($Mesto)
;Exit
;ConsoleWrite ( " All good! " & $fil & @CRLF)


;FileWriteLine($fil, @CRLF & "   " & $N & " " &  @CRLF)
;  
FileWrite($fil, "" & @TAB & "" & @TAB)
For $j = 1 To $Nt
   FileWrite($fil, "R" & $j & @TAB)
Next
FileWriteLine($fil, "" & @TAB & "" & @TAB & "" & @TAB & "")

For $i = 1 To $N ;  
   FileWrite($fil, $i & @TAB & $Name[$Num[$i]] & @TAB)
   For $j = 1 To $Nt ;    -    ( )  
	  If StringMid($aArray[$Num[$i]],59+$j*11,1) = '-' Then
		 FileWrite($fil, '+' & @TAB)
	  Else
;                                        -              W  B
		 FileWrite($fil, $Mesto[StringMid($aArray[$Num[$i]],62+$j*11,2)] & StringMid($aArray[$Num[$i]],59+$j*11,1))
		 $tmp = StringMid($aArray[$Num[$i]],60+$j*11,1) ;   
		 If $tp = 0 Then
			If $tmp = '' Then $tmp = 'S'
			FileWrite($fil, $tmp & @TAB)
		 Else
			FileWrite($fil, (Asc($tmp) - Asc("A")) / 2 & @TAB)
		 EndIf
	  EndIf
   Next
   FileWrite($fil, $Sum[$Num[$i]] & @TAB & $Kb[$Num[$i]] & @TAB & $Zb[$Num[$i]] & @TAB & $KbBH[$Num[$i]] & @CRLF) ;  
Next

;Exit

;  
$oWord = _Word_Create()       ;    Word
$oDoc =_Word_DocAdd($oWord)   ;     Word 
Const $WrdConst=2.835         ;   .    1      2.835

With $oDoc.PageSetup
   .PaperSize = 7                    ; wdPaperA4
   .Orientation = $WdOrientLandscape ;   -  :)
   .LeftMargin = 20*$WrdConst
   .RightMargin = 20*$WrdConst
   .TopMargin = 10*$WrdConst
   .BottomMargin = 1*$WrdConst
EndWith

$oRange = _Word_DocRangeSet($oDoc, -2)     ;     Word 
$oDoc.Tables.Add($oRange, 4+$N, 6+$Nt)     ;   
$oDoc.Tables(1).Style = " "    ;   
 ;      1 
With $oDoc.Tables.Item(1)
   .TopPadding = 0.1*$WrdConst;
   .BottomPadding = 0.1*$WrdConst;
   .RightPadding = 1*$WrdConst;
   .LeftPadding = 1*$WrdConst;
EndWith
;    
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,3+$N,1)
$oWord.Application.Selection.MoveDown($wdLine,5+$N,1)
With $oWord.Application.Selection
   .Font.Name='Times New Roman'
   .Font.Size = 12
   .ParagraphFormat.Alignment = 1 ;   
   .Cells.VerticalAlignment = 1 ; wdAlignVerticalCenter
   .ParagraphFormat.SpaceBefore = 0
   .ParagraphFormat.SpaceBeforeAuto = False
   .ParagraphFormat.SpaceAfter = 0
   .ParagraphFormat.SpaceAfterAuto = False
   .ParagraphFormat.LineUnitBefore = 0
   .ParagraphFormat.LineUnitAfter = 0
EndWith

;      
$oDoc.Tables.Item(1).Rows(1).Height=7*$WrdConst      ;  1-  7 
$oDoc.Tables.Item(1).Rows(2).Height=7*$WrdConst      ;  2-  7 
For $i = 3 To 2+$N
   $oDoc.Tables.Item(1).Rows(4+$N).Height=6*$WrdConst  ;    99 
Next
$oDoc.Tables.Item(1).Rows(4+$N).Height=10*$WrdConst  ;    10 

$oDoc.Tables.Item(1).Columns(1).Width=8*$WrdConst   ;  1-  8  - 
$oDoc.Tables.Item(1).Columns(2).Width=53*$WrdConst  ;  2-  53 

$WidthOfRez = 15 ;      -    11,   15
If $tp = 0 Then $WidthOfRez = 11
$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt-1,1) ;      
$oWord.Application.Selection.MoveDown($wdLine,3+$N,1)        ;
$oWord.Application.Selection.Cells.Width=$WidthOfRez*$WrdConst        ;     99w0  99w2.5
;    
$oDoc.Tables(1).Cell(3,1).Range.Text = " "
$oDoc.Tables(1).Cell(3,2).Range.Text = ""
For $j = 1 To $Nt
 ;  $oDoc.Tables.Item(1).Cell(3+$j,2+$j).Select
 ;  $oWord.Application.Selection.Cells.Shading.Texture = 0x0000015E   ; 
   $oDoc.Tables(1).Cell(3,2+$j).Range.Text = "R"&$j                  ;  
   $oDoc.Tables(1).Cell(3,2+$j).Range.Font.Size = 11
Next
$oDoc.Tables(1).Cell(3,3+$Nt).Range.Text = ""
$oDoc.Tables(1).Cell(3,4+$Nt).Range.Text = ""   ;  
$oDoc.Tables(1).Cell(3,5+$Nt).Range.Text = ""   ;  
$oDoc.Tables(1).Cell(3,6+$Nt).Range.Text = "-"   ;  

For $i = 1 To $N ;-$N
   $oDoc.Tables(1).Cell(3+$i,1).Range.Text = $i                     ;  
   $oDoc.Tables(1).Cell(3+$i,1).Range.Font.Bold = 1
   $oDoc.Tables(1).Cell(3+$i,2).Range.Text = $Name[$Num[$i]]        ;  
   $oDoc.Tables(1).Cell(3+$i,2).Range.Font.Bold = 1
   For $j = 1 To $Nt ;    -    ( )  
  	  If StringMid($aArray[$Num[$i]],59+$j*11,1) = '-' Then
		 $r = '+'
	  Else
;                                        -              W  B
		 $r = $Mesto[StringMid($aArray[$Num[$i]],62+$j*11,2)] & StringMid($aArray[$Num[$i]],59+$j*11,1)
		 $tmp = StringMid($aArray[$Num[$i]],60+$j*11,1) ;   
		 If $tp = 0 Then
			If $tmp = '' Then $tmp = 'S'
			$r = $r & $tmp
		 Else
			$r = $r & (Asc($tmp) - Asc("A")) / 2
		 EndIf
	  EndIf
	  $oDoc.Tables(1).Cell(3+$i,2+$j).Range.Text = $r
	  $oDoc.Tables(1).Cell(3+$i,2+$j).Range.Font.Size = 10
   Next
   $oDoc.Tables(1).Cell(3+$i,3+$Nt).Range.Text = $Sum[$Num[$i]]   ;    
   $oDoc.Tables(1).Cell(3+$i,3+$Nt).Range.Font.Bold = 1
   $oDoc.Tables(1).Cell(3+$i,4+$Nt).Range.Text = $Kb[$Num[$i]]   ;  
   $oDoc.Tables(1).Cell(3+$i,5+$Nt).Range.Text = $Zb[$Num[$i]]   ;  
   $oDoc.Tables(1).Cell(3+$i,6+$Nt).Range.Text = $KbBH[$Num[$i]] ;  
Next
;     -  .   
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1)
$oWord.Application.Selection.MoveDown($wdLine,1,1)
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 0
$oWord.Application.Selection.Cells.Borders.InsideLineStyle = 0
$oDoc.Tables.Item(1).Cell(4+$N,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1) ;    
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 0
$oWord.Application.Selection.Cells.Borders.InsideLineStyle = 0
;  
$oDoc.Tables.Item(1).Cell(3,1).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt+5,1) ;    
$oWord.Application.Selection.MoveDown($wdLine,$N,1)          ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
$oDoc.Tables(1).Rows(3).Borders.OutsideLineStyle = 7
$oDoc.Tables.Item(1).Cell(3,3).Select
$oWord.Application.Selection.MoveRight($wdCharacter,$Nt-1,1) ;      
$oWord.Application.Selection.MoveDown($wdLine,$N,1)        ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
$oDoc.Tables.Item(1).Cell(3,$Nt+3).Select
$oWord.Application.Selection.MoveDown($wdLine,$N,1)          ;
$oWord.Application.Selection.Cells.Borders.OutsideLineStyle = 7 ;  
;        -     
$oDoc.Tables.Item(1).Cell(1,1).Merge($oDoc.Tables.Item(1).Cell(1,6+$Nt))
$oDoc.Tables.Item(1).Cell(1,1).Split(1,3);
$oDoc.Tables(1).Cell(1,1).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(1,3).Range.Text = ": " & @MDAY & '.' & @MON & '.' & @YEAR
$oDoc.Tables.Item(1).Cell(1,3).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight
$oDoc.Tables(1).Cell(1,2).Range.Text = "                 "
If $Tname = '' Then
   $oDoc.Tables(1).Cell(2,1).Range.Text = "     !"
Else
   $oDoc.Tables(1).Cell(2,1).Range.Text = $Tname
EndIf
$oDoc.Tables(1).Cell(2,1).Range.Font.Bold = 1
$oDoc.Tables(1).Cell(2,1).Range.Font.Size = 16
$oDoc.Tables.Item(1).Cell(2,1).Merge($oDoc.Tables.Item(1).Cell(2,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Merge($oDoc.Tables.Item(1).Cell(4+$N,6+$Nt))
$oDoc.Tables.Item(1).Cell(4+$N,1).Split(1,2);
$oDoc.Tables(1).Cell(4+$N,1).Range.Text = "  ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,1).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 0 ;wdAlignParagraphLeft
$oDoc.Tables(1).Cell(4+$N,2).Range.Text = " ____________________"
$oDoc.Tables.Item(1).Cell(4+$N,2).Select
$oWord.Application.Selection.ParagraphFormat.Alignment = 2 ;wdAlignParagraphRight


ConsoleWrite ( " All good! " & UBound($aArray) & @CRLF)

Exit



Func My_Err($OutText) ;    -    
    MsgBox(0, '!!  ', $OutText)
	Exit
EndFunc

Func Swap($i, $j)
   $kk = $Num[$i]
   $Num[$i] = $Num[$j]
   $Num[$j] = $kk
EndFunc
